﻿// Copyright (c) Strange Loop Games. All rights reserved.
// See LICENSE file in the project root for full license information.
// <auto-generated from VehicleTemplate.tt />

namespace Eco.Mods.TechTree
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using Eco.Core.Items;
    using Eco.Gameplay.Components;
    using Eco.Gameplay.Components.Auth;
    using Eco.Gameplay.Components.VehicleModules;
    using Eco.Gameplay.GameActions;
    using Eco.Gameplay.DynamicValues;
    using Eco.Gameplay.Interactions;
    using Eco.Gameplay.Items;
    using Eco.Gameplay.Objects;
    using Eco.Gameplay.Players;
    using Eco.Gameplay.Skills;
    using Eco.Gameplay.Systems.TextLinks;
    using Eco.Shared.Math;
    using Eco.Shared.Networking;
    using Eco.Shared.Localization;
    using Eco.Shared.Serialization;
    using Eco.Shared.Utils;
    using Eco.Shared.Items;
    using Eco.Gameplay.Systems.Tooltip;
    using Eco.Gameplay.Systems.NewTooltip;
    using Eco.Core.Controller;
    using System.Xml.Linq;
    using Eco.Core.PropertyHandling;
    using System.Linq;
    using Eco.Gameplay.Aliases;
    using System.Threading;

    [Serialized]
    [LocDisplayName("Wood Shop Cart")]
    [Weight(15000)]
    [Ecopedia("Crafted Objects", "Vehicles", createAsSubPage: true)]
    public partial class WoodShopCartItem : WorldObjectItem<WoodShopCartObject>, IPersistentData
    {
        public override LocString DisplayDescription { get { return Localizer.DoStr("A store in a wooden cart, very useful when your customers are far away."); } }
        [Serialized, SyncToView, TooltipChildren, NewTooltipChildren(CacheAs.Instance)] public object PersistentData { get; set; }
    }

    /// <summary>
    /// <para>Server side recipe definition for "WoodShopCart".</para>
    /// <para>More information about RecipeFamily objects can be found at https://docs.play.eco/api/server/eco.gameplay/Eco.Gameplay.Items.RecipeFamily.html</para>
    /// </summary>
    /// <remarks>
    /// This is an auto-generated class. Don't modify it! All your changes will be wiped with next update! Use Mods* partial methods instead for customization. 
    /// If you wish to modify this class, please create a new partial class or follow the instructions in the "UserCode" folder to override the entire file.
    /// </remarks>
    [RequiresSkill(typeof(BasicEngineeringSkill), 1)]
    [Ecopedia("Crafted Objects", "Vehicles", subPageName: "Wood Shop Cart Item")]
    public partial class WoodShopCartRecipe : RecipeFamily
    {
        public WoodShopCartRecipe()
        {
            var recipe = new Recipe();
            recipe.Init(
                name: "WoodShopCart",  //noloc
                displayName: Localizer.DoStr("Wood Shop Cart"),

                // Defines the ingredients needed to craft this recipe. An ingredient items takes the following inputs
                // type of the item, the amount of the item, the skill required, and the talent used.
                ingredients: new List<IngredientElement>
                {
                    new IngredientElement(typeof(CottonFabricItem), 12, typeof(BasicEngineeringSkill)),
                    new IngredientElement("Lumber", 8, typeof(BasicEngineeringSkill)), //noloc
                    new IngredientElement(typeof(WoodCartItem), 1, true),
                    new IngredientElement(typeof(StoreItem), 1, true),
                },

                // Define our recipe output items.
                // For every output item there needs to be one CraftingElement entry with the type of the final item and the amount
                // to create.
                items: new List<CraftingElement>
                {
                    new CraftingElement<WoodShopCartItem>()
                });
            this.Recipes = new List<Recipe> { recipe };
            this.ExperienceOnCraft = 10; // Defines how much experience is gained when crafted.

            // Defines the amount of labor required and the required skill to add labor
            this.LaborInCalories = CreateLaborInCaloriesValue(225, typeof(BasicEngineeringSkill));

            // Defines our crafting time for the recipe
            this.CraftMinutes = CreateCraftTimeValue(beneficiary: typeof(WoodShopCartRecipe), start: 2, skillType: typeof(BasicEngineeringSkill));

            // Perform pre/post initialization for user mods and initialize our recipe instance with the display name "Wood Shop Cart"
            this.ModsPreInitialize();
            this.Initialize(displayText: Localizer.DoStr("Wood Shop Cart"), recipeType: typeof(WoodShopCartRecipe));
            this.ModsPostInitialize();

            // Register our RecipeFamily instance with the crafting system so it can be crafted.
            CraftingComponent.AddRecipe(tableType: typeof(WainwrightTableObject), recipe: this);
        }

        /// <summary>Hook for mods to customize RecipeFamily before initialization. You can change recipes, xp, labor, time here.</summary>
        partial void ModsPreInitialize();

        /// <summary>Hook for mods to customize RecipeFamily after initialization, but before registration. You can change skill requirements here.</summary>
        partial void ModsPostInitialize();
    }

    [Serialized]
    [RequireComponent(typeof(StoreComponent), null)] // toto je skryta komponenta
    [RequireComponent(typeof(StandaloneAuthComponent))]
    [RequireComponent(typeof(PublicStorageComponent))]
    [RequireComponent(typeof(TailingsReportComponent))]
    [RequireComponent(typeof(MovableLinkComponent))]
    [RequireComponent(typeof(VehicleComponent))]
    [RequireComponent(typeof(ModularStockpileComponent))]
    [RequireComponent(typeof(MinimapComponent))]
    [RequireComponent(typeof(CustomTextComponent), null)]
    [Ecopedia("Crafted Objects", "Vehicles", subPageName: "WoodShopCart Item")]
    public partial class WoodShopCartObject : PhysicsWorldObject, IRepresentsItem
    {
        static WoodShopCartObject()
        {
            WorldObject.AddOccupancy<WoodShopCartObject>(new List<BlockOccupancy>(0));
        }
        public override TableTextureMode TableTexture => TableTextureMode.Wood;
        public override bool PlacesBlocks => false;
        public override LocString DisplayName { get { return Localizer.DoStr("Wood Shop Cart"); } }
        public Type RepresentedItemType { get { return typeof(WoodShopCartItem); } }

        // vlastni promenne

        private const int UpdateTime = 2; // 2s
        private const int UpdateOnOffTime = 10; // 60min

        private DateTime lastTickTime = DateTime.Now.AddSeconds(-UpdateTime);

        public bool IsClearStorage { get; private set; } = false;
        public bool IsInfiniteItems { get; private set; } = false;
        public bool IsInfiniteStacks { get; private set; } = false;
        public bool IsApply { get; private set; } = false;

        private WoodShopCartObject() { }
        protected override void Initialize()
        {
            base.Initialize();
            this.GetComponent<VehicleComponent>().HumanPowered(2);
            this.GetComponent<StockpileComponent>().Initialize(new Vector3i(2, 1, 2));
            this.GetComponent<PublicStorageComponent>().Initialize(12 * 2, 999999999);
            this.GetComponent<MinimapComponent>().InitAsMovable();
            this.GetComponent<MinimapComponent>().SetCategory(Localizer.DoStr("Vehicles"));
            this.GetComponent<VehicleComponent>().Initialize(10, 1, 1);

            var text = this.GetComponent<CustomTextComponent>();
            text.Initialize(700);
            text.TextData.PropertyChanged += (sender, e) => {
                MemberChangedBeforeAfterEventArgs evt = e as MemberChangedBeforeAfterEventArgs;
                string msg = evt.After as string;
                TextDataChange(msg);
            };
        }

        public override void Tick()
        {
            if (lastTickTime < DateTime.Now.AddSeconds(-UpdateTime))
            {
                if (!IsApply)
                {
                    var text = GetComponent<CustomTextComponent>();
                    TextDataChange(text.TextData.Text);
                    IsApply = true;
                }
                if (IsClearStorage)
                {
                    GetComponent<PublicStorageComponent>().Storage.Clear();
                }
                if (IsInfiniteItems)
                {
                    var storage = GetComponent<PublicStorageComponent>();
                    storage?.Inventory?.Stacks?.Where(p => p.Quantity > 0).ForEach(s => {
                        // nutne pouzit vychozi velikost stacku, pokud neni povoleno neomezeno
                        s.Quantity = IsInfiniteStacks ? 99999 : s.Item.MaxStackSize;
                    });
                }
                lastTickTime = DateTime.Now;
            }
            base.Tick();
        }

        private void TextDataChange(string msg)
        {
            // byla zmenena zprava (udalost Save)
            if (msg != null)
            {
                // vlastnik musi byt admin

                var ownerUser = Owners?.FirstUser() ?? null;
                if (ownerUser == null || !ownerUser.IsAdmin)
                {
                    return;
                }

                // vychozi hodnoty

                IsClearStorage = false;
                IsInfiniteItems = false;
                IsInfiniteStacks = false;

                var storage = GetComponent<PublicStorageComponent>();
                storage.Storage.ClearRestrictions();
                storage.ShelfLifeMultiplier = 1f;
                storage.Inventory.ShelfLifeMultiplier = 1f;

                // zprava musi zacinat "begin" a koncit "end"

                string[] lines = msg.SplitToLines();
                if (lines.Length > 2 && lines[0] == "[begin]" && lines[lines.Length - 1] == "[end]")
                {
                    // projde jednotlive prikazy (co radek, to jeden prikaz)
                    lines.Skip(1).Take(lines.Length - 2).ToArray().ForEach(line => {
                        string lowerLine = line.ToLower();
                        switch (lowerLine)
                        {
                            // jednou za cas smaze vsechny predmety (vhodne pro obchod typu BUY)
                            case "clearstorage":
                                IsClearStorage = true;
                                break;

                            // do jednoho stacku se vejde neomezene mnozstvi predmetu
                            case "infinitestacks":
                                IsInfiniteStacks = true;
                                GetComponent<PublicStorageComponent>().Storage.AddInvRestriction(new StackLimitRestriction(int.MaxValue, true));
                                break;

                            // jidlo se nikdy nezkazi
                            case "foodnotspoil":
                                var storage = GetComponent<PublicStorageComponent>();
                                storage.ShelfLifeMultiplier = short.MaxValue;
                                storage.Inventory.ShelfLifeMultiplier = short.MaxValue;
                                break;

                            // predmety nikdy nedojdou
                            case "infiniteitems":
                                IsInfiniteItems = true;
                                break;
                        }
                    });
                }
            }
        }
    }
}
